################################################################################
##
## Subversion file information - please do not edit this block
## $Rev: 882 $
## $Date: 2011-01-10 09:06:33 +0100 (Mon, 10 Jan 2011) $
## $Author: nash $
## $Id: split1.births.R 882 2011-01-10 08:06:33Z nash $
##
################################################################################

split1.births <-
function(dta,exps,verbose=TRUE) {

# splits 1 year age groups (RR/VV) data using piece-wise 
# cubic hermite interpolating polynomial spline

 years=unique(dta$Year);
 dta=dta[order(dta$Year,dta$Age),];
 dtaR=dta[dta$Age==300 | dta$Age==-1,];
 dta=dta[dta$Age!=300 & dta$Age!=-1,];
 
 if (verbose) cat('1-year age groups into Lexis triangles\n')
 
 for (y in years) {
    dtay=dta[dta$Year==y,]
    if (length(dtay$Age[dtay$Lexis!='TL' & dtay$Lexis!='TU'])==0) {
       dtaR=rbind(dtaR,dtay)
       }
    else {
      if (verbose && y %% 10 == 0) cat('\n')
      if (verbose) cat(y,' ')
      dtaRy=NULL
      if (length(unique(dtay$BirthOrder))>=5) {
        for (b in 0:max(dtay$BirthOrder)) {
         dtas=split1(dtay[dtay$BirthOrder==b,],exps[exps$Year==y,]);
         dtaRy=rbind(dtaRy,dtas)
         }
        dtaR=rbind(dtaR,indb.IPF(dtaRy[order(dtaRy$BirthOrder,dtaRy$Age,dtaRy$Lexis),],dtay$Age[dtay$BirthOrder==0],dtay$Lexis[dtay$BirthOrder==0]));
       }
      else {
        dtas=split1(dtay[dtay$BirthOrder==0,],exps[exps$Year==y,]);
        dtaR=rbind(dtaR,dtas);
        } 
      }  
    }
 if (verbose) cat('\n');
 return(dtaR[order(dtaR$Year,dtaR$BirthOrder,dtaR$Age),])
}

