################################################################################
##
## Subversion file information - please do not edit this block
## $Rev: 882 $
## $Date: 2011-01-10 09:06:33 +0100 (Mon, 10 Jan 2011) $
## $Author: nash $
## $Id: indb.standard.R 882 2011-01-10 08:06:33Z nash $
##
################################################################################

indb.standard <-
function(indb=NA,fname="", minA=10, maxA=60, maxO=5,print=FALSE) {
# converts to standard age/birth oder scale (aggregates by birth order and adds missed ages)

#to do: VH
 if(length(indb)<=1) {
  indb=indbLoad(fname);
  }
 indb=indb[indb$LDB==1,]
 indbR=indb[indb$Age==300 | indb$Age==-1,];
 indb=indb[indb$Age!=300 & indb$Age!=-1,];
 minA=min(minA,indb$Age);
 maxA=max(maxA,indb$Age);
 #age
 for (y in unique(indb$Year)) {
   dta=indb[indb$Year==y,];
   for (bo in unique(dta$BirthOrder)) {
    dta1=dta[dta$BirthOrder==bo,]
    indbR=rbind(indbR,missing.ages(dta1,minA=minA,maxA=maxA))
    }
   }
 #browser()
 indb=rbind(indb,indbR);
 indb=indb[order(indb$Year,indb$BirthOrder,indb$Age),];
 indbR=indb[indb$BirthOrder<5,];
 indb=indb[indb$BirthOrder>=5,];
 if (dim(indb)[1]>0) {
   indb$OrderInt='+'
   }
 for (y in unique(indb$Year)) {
   indby=indb[indb$Year==y,];
   indb5=indby[indby$BirthOrder==maxO,];
   indb6p=indby[indby$BirthOrder>maxO,];
   if (dim(indb6p)[1]>0) {
      for (bo in unique(indb6p$BirthOrder)) {
         indb5$Births=indb5$Births+indb6p$Births[indb6p$BirthOrder==bo]
         }
      }
   indbR=rbind(indbR,indb5);
   }
 
 #birth order
 indbR=indbR[order(indbR$Year,indbR$BirthOrder,indbR$Age),];
 dta$Lexis[dta$Lexis=='TU' & dta$AgeInt==100]='VV'
 dta$Age[dta$Lexis=='TL' & dta$AgeInt==-100]=dta$Age[dta$Lexis=='TL' & dta$AgeInt==-100]-1
 dta$Lexis[dta$Lexis=='TL' & dta$AgeInt==-100]='VV'

 if(print) indb.print(indbR);
 return(indbR)
}

