################################################################################
##
## Subversion file information - please do not edit this block
## $Rev: 882 $
## $Date: 2011-01-10 09:06:33 +0100 (Mon, 10 Jan 2011) $
## $Author: nash $
## $Id: split1.R 882 2011-01-10 08:06:33Z nash $
##
################################################################################

split1 <-
function(births, exps, monthly=vector(mode='numeric',12)+1,delta=1e-4) {
 if (nrow(births) == 0 || (all(births$Lexis %in% c("TL", "TU") & births$AgeInt == 1))) return(births)
 if (births$Lexis[births$Lexis!='TL' & births$Lexis!='TU'][1]=='VV') {
  Lexis='VV'
  TR1=1; #TL
  TR2=2; #TU
  ti=1;
  }
 else {
  Lexis='RR'
  TR1=2; #TU
  TR2=1; #TL
  ti=0; #age shift for VV
  }

 birthsRes=births[births$Lexis=='TL' | births$Lexis=='TU',]
 births=aggregateLexis.births(births,Lexis=Lexis)
 
 
 mdens=vector(mode='numeric',1/delta);
 dm=(1/delta)/12;
 for (i in 1:12) {
    mdens[floor((i-1)*dm+1):floor(i*dm)]=mdens[floor((i-1)*dm+1):floor(i*dm)]=monthly[i]*delta;
    }
 mdens[(i*dm):length(mdens)]=monthly[12]*delta;
 mdens=cumsum(mdens);
 if (Lexis=='VV') {
  mdens=1-mdens;
  }
 brate=births$Births/exps.aggregate.age(exps, births$Age, births$AgeInt, Lexis=Lexis);
 cbrate=cumsum(brate);
 n=length(cbrate);
 pbrate=cbrate[1:(n-1)]/cbrate[n];
 Fx=log(pbrate/(1-pbrate));
 
 Fx[Fx==Inf]=max(Fx[Fx!=Inf & Fx!=-Inf]+2,12);
 Fx[Fx==-Inf]=min(-20,Fx[Fx!=-Inf]-0.5);
 Fx=c(Fx,max(Fx,12))
 age=births$Age+1
# age[births$Lexis=='TL' | births$Lexis=='TU']=age[births$Lexis=='TL' | births$Lexis=='TU']-0.5;
 if (min(age)>15) {age=c(15,age); Fx=c(min(Fx,min(-12,Fx-0.5)),Fx);}
 if (min(age)>12) {age=c(12,age); Fx=c(min(Fx,min(-20,Fx-0.5)),Fx);}
 if (max(age)<60) {age=c(age,60); Fx=c(Fx,max(Fx+2,12));}
 ageTR=seq(min(age),max(age),delta);
 FxTR=interp1(age, Fx, ageTR,'pchip');
 cbrateTR=cbrate[n]*exp(FxTR)/(1+exp(FxTR));
 
 fxTR=matrix(diff(cbrateTR),1/delta);
 brateTR=fxTR*matrix(mdens,length(mdens),dim(fxTR)[2]);
 brateTR1=fxTR*matrix(1-mdens,length(mdens),dim(fxTR)[2]);
 brateTR=2*colSums(brateTR);
 brateTR1=2*colSums(brateTR1);
 Births=brateTR*exps$Exposure[exps$Age>=(min(ageTR)+ti) & exps$Age<(max(ageTR)+ti) & exps$Triangle==TR1];
 Births1=brateTR1*exps$Exposure[exps$Age>=min(ageTR) & exps$Age<max(ageTR) & exps$Triangle==TR2];
 BirthsTR=matrix(0,2,length(births$Age))
 age1=(min(age)-1):(max(age)-1)
 Births=c(0,Births)
 for(i in 1:length(births$Age)) {
  BirthsTR[2,i]=Births[age1==births$Age[i]]
  BirthsTR[1,i]=2*exps$Exposure[exps$Age==births$Age[i] & exps$Triangle==TR2]*
                   (births$Births[i]/(sum(exps$Exposure[exps$Age==births$Age[i]]))
                   -0.5*BirthsTR[2,i]/(exps$Exposure[exps$Age==births$Age[i] & exps$Triangle==TR1]))
#  BirthsTR[,i]=round(BirthsTR[,i],2)
  if (sum(BirthsTR[,i])>0) {                
    if((BirthsTR[1,i]==0 & BirthsTR[2,i]<10) | (BirthsTR[2,i]==0 & BirthsTR[1,i]<10)) BirthsTR[,i]=births$Births[i]/2
    else BirthsTR[,i]=BirthsTR[,i]*births$Births[i]/sum(BirthsTR[,i]);                 
    }
  else {BirthsTR[,i]=0}
  }
 BirthsTR=as.vector(BirthsTR); 
 dtaRes=data.frame(matrix(NA,length(BirthsTR),19));
 names(dtaRes)<-c('PopName','Area','Year','YearReg','Age','AgeInt','Lexis','BirthOrder',
                  'OrderInt','PrevBirth','DurInt','Vital','Births','Access','Note1','Note2','Note3','RefCode','LDB');
 dtaRes$PopName=births$PopName[1];
 dtaRes$Area=births$Area[1];
 dtaRes$Year=births$Year[1];
 dtaRes$YearReg=births$YearReg[1];
 dtaRes$Age=as.vector(t(matrix(births$Age,length(births$Age),2)));
 dtaRes$AgeInt=1;
 if (Lexis=='VV') {
   dtaRes$Lexis=matrix(c('TL','TU'),length(BirthsTR),1);
   dtaRes$Age[dtaRes$Lexis=='TL']=dtaRes$Age[dtaRes$Lexis=='TL']+1
   if (min(dtaRes[dtaRes$Lexis == 'TL', 'Age']) > 12) {
   # need to add births 0 in age 12 lower triangle as this was not calculated
     dtaRes <- rbind(dtaRes[1, ], dtaRes)
     dtaRes[1, "Age"] <- 12
     dtaRes[1, "Lexis"] <- "TL"
     BirthsTR <- c(0, BirthsTR)
     }
   }
 else {
   dtaRes$Lexis=matrix(c('TL','TU'),length(BirthsTR),1);
   }
 dtaRes$BirthOrder=births$BirthOrder[1];
 dtaRes$OrderInt=births$OrderInt[1];
 dtaRes$Vital=births$Vital[1];
 dtaRes$Births=BirthsTR;
 dtaRes$Access='O';
 dtaRes$RefCode=99;
 dtaRes$LDB=1;
 
 for (i in 1:dim(birthsRes)[1]) {
    dtaRes$LDB[dtaRes$Age==birthsRes$Age[i] & dtaRes$Lexis==birthsRes$Lexis[i]]=0;
    }           
 dtaRes=dtaRes[dtaRes$LDB==1,]   
 dtaRes=rbind(birthsRes,dtaRes)

 return(dtaRes);
}

