%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%
%% Subversion file information - please do not edit this block
%% $Rev: 596 $
%% $Date: 2010-09-13 08:36:29 +0200 (Mon, 13 Sep 2010) $
%% $Author: nash $
%% $Id: indb.print.Rd 596 2010-09-13 06:36:29Z nash $
%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\name{indb.print}
\alias{indb.print}
\title{
  Export an HFD input database from internal format to a file
}
\description{
  This function serialises an HFD input database from the internal format used in
  inputDB processing to the standard CSV file format.
}
\usage{
indb.print(indb, fname = "")
}
\arguments{
  \item{indb}{
  A data frame representing an HFD births input file in internal format
}
  \item{fname}{
  A filename to write to. Default is [PopName]births.txt in the working directory.
}
}
\value{
  None. \code{indb} is written to file.
}
\author{
  Dmitri Jdanov \email{jdanov@demogr.mpg.de}
}
\note{
  Note that this function does not undo the changes made to Year/YearReg by
  \code{\link{indbLoad}} and so the combination of the functions does not round-trip
  the input database.
}
\seealso{
  \code{\link{indbLoad}} for deserialisation
}
\examples{
}
